#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>

#define F_CPU 8000000UL
#include <util/delay.h>
#include "muldisp.h"
#include "uart.h"

#define UART_BAUDRATE	9600
//static FILE mystdout = FDEV_SETUP_STREAM(uart_putc, NULL,
 //                                            _FDEV_SETUP_WRITE);


void muldisp_init (void);
unsigned char muldisp_get_sign(void);
unsigned char muldisp_get_segs_dig1(void);
unsigned char muldisp_get_segs_dig2(void);
unsigned char muldisp_get_segs_dig3(void);
unsigned char muldisp_get_segs_dig4(void);
unsigned char muldisp_segs_to_dig(unsigned char segs);

int main(void)
{

#ifdef bla_dennis

    unsigned char SEGS1=0,SEGS2=0,SEGS3=0,SEGS4=0;
    unsigned char DIG1=' ',DIG2=' ',DIG3=' ',DIG4=' ',SIGN=' ';
    

    muldisp_init();

    //stdout = &mystdout;
    sei();
    uart_init(UART_BAUD_SELECT(UART_BAUDRATE, F_CPU));

    while(1)
    {
        while(MULDISP_BACKIS_OFF);
        uart_putc(SIGN);
        uart_putc(DIG4);
        uart_putc(DIG3);
        uart_putc(DIG2);
        uart_putc(DIG1);
        uart_putc('\r');
        //re=uart_getc();
        //printf("H");
        

        while(MULDISP_BACKIS_ON);

         _delay_ms(1);
        SEGS1=muldisp_get_segs_dig1();
        SEGS2=muldisp_get_segs_dig2();       
        SEGS3=muldisp_get_segs_dig3();
        SEGS4=muldisp_get_segs_dig4();
        
        SIGN=muldisp_get_sign();
        DIG1=muldisp_segs_to_dig(SEGS1);
        DIG2=muldisp_segs_to_dig(SEGS2);
        DIG3=muldisp_segs_to_dig(SEGS3);
        DIG4=muldisp_segs_to_dig(SEGS4);

        _delay_ms(30);
        _delay_ms(30);
        _delay_ms(30);
        _delay_ms(30);
        _delay_ms(30);
        _delay_ms(30);
        _delay_ms(30);
        _delay_ms(30);
    }

#endif
	
    DDRB    |= (1<<3);  // port D Pin 3,Output  
    /*DDRD    &=~ (1<<5);  // port D Pin 5,INPUT   
    DDRD    |= (1<<6);  // port D Pin 6,Output   


    DDRB    |= (1<<1);  // port B Pin 1,Output   
    DDRB    |= (1<<2);  // port B Pin 1,Output   
    DDRB    |= (1<<3);  // port B Pin 1,Output   
	*/
    while(1)
	{
		//while(PIND&0x20);

		    PORTB   &=~(1<<3);
			//_delay_ms(.1);
            asm("NOP");
            asm("NOP");
			PORTB   |=(1<<3);
            //_delay_ms(.1);

		//while(0x20&~PIND);

	}
	
	
	/*while(1)
	{

		_delay_ms(10);//max 32ms @ 8mhz

		if(PORTD&0x40)
		{
		    PORTD   &=~(1<<6);
		}
		else
		{
			PORTD   |=(1<<6);
		}
	}*/
}
void muldisp_init (void)
{
    MULDISP_SEGA1_IN;
    MULDISP_SEGB1_IN;
    MULDISP_SEGE1_IN;
    MULDISP_SEGF1_IN;
    MULDISP_SEGG1_IN;

    MULDISP_SEGA2_IN;
    MULDISP_SEGB2_IN;
    MULDISP_SEGE2_IN;
    MULDISP_SEGF2_IN;
    MULDISP_SEGG2_IN;

    MULDISP_SEGA3_IN;
    MULDISP_SEGB3_IN;
    MULDISP_SEGE3_IN;
    MULDISP_SEGF3_IN;
    MULDISP_SEGG3_IN;

    MULDISP_SEGBC4_IN;
    MULDISP_SEGG4_IN;

    MULDISP_BACK_IN;
}
unsigned char muldisp_get_sign(void)
{
    if(MULDISP_SEGG4IS_ON)
    {
        return '-';
    }
    else
    {
        return ' ';
    }
}


unsigned char muldisp_get_segs_dig1(void)
{
unsigned char segs1=0;
        if(MULDISP_SEGA1IS_ON)
                    segs1|=0x01;
        if(MULDISP_SEGB1IS_ON)
                    segs1|=0x02;
        if(MULDISP_SEGE1IS_ON)
                    segs1|=0x04;
        if(MULDISP_SEGF1IS_ON)
                    segs1|=0x08;
        if(MULDISP_SEGG1IS_ON)
                    segs1|=0x10;

    return (segs1);
}

unsigned char muldisp_get_segs_dig2(void)
{
unsigned char segs2=0;
        if(MULDISP_SEGA2IS_ON)
                    segs2|=0x01;
        if(MULDISP_SEGB2IS_ON)
                    segs2|=0x02;
        if(MULDISP_SEGE2IS_ON)
                    segs2|=0x04;
        if(MULDISP_SEGF2IS_ON)
                    segs2|=0x08;
        if(MULDISP_SEGG2IS_ON)
                    segs2|=0x10;

    return (segs2);
}

unsigned char muldisp_get_segs_dig3(void)
{
unsigned char segs3=0;
        if(MULDISP_SEGA3IS_ON)
                    segs3|=0x01;
        if(MULDISP_SEGB3IS_ON)
                    segs3|=0x02;
        if(MULDISP_SEGE3IS_ON)
                    segs3|=0x04;
        if(MULDISP_SEGF3IS_ON)
                    segs3|=0x08;
        if(MULDISP_SEGG3IS_ON)
                    segs3|=0x10;

    return (segs3);
}

unsigned char muldisp_get_segs_dig4(void)
{
unsigned char segs4=0;
        if(MULDISP_SEGBC4IS_ON)
                    segs4|=0x02;
    return (segs4);
}


unsigned char muldisp_segs_to_dig(unsigned char segs)
{
unsigned char dig;

    switch (segs)
    {
        case 0x00:
        {
            dig=' ';
            break;
        }
        case 0x0f:
        {
            dig='0';
            break;
        }
        case 0x02:
        {
            dig='1';
            break;
        }
        case 0x17:
        {
            dig='2';
            break;
        }
        case 0x13:
        {
            dig='3';
            break;
        }
        case 0x1A:
        {
            dig='4';
            break;
        }
        case 0x19:
        {
            dig='5';
            break;
        }
        case 0x1D:
        {
            dig='6';
            break;
        }
        case 0x03:
        {
            dig='7';
            break;
        }
        case 0x1F:
        {
            dig='8';
            break;
        }
        case 0x1B:
        {
            dig='9';
            break;
        }
        default:
        {
            dig='-';
            break;
        }
    }
    return (dig);
}
